#!/usr/bin/perl
use strict;
use GffTranscriptReader;
use SummaryStats;

my $usage="$0 <*.gff> <percent> <selected.gff> <not-selected.gff>";
die "$usage\n" unless @ARGV==4;
my ($filename,$percent,$out1,$out2)=@ARGV;

if($percent<0 || $percent>1) {die "percent must be between 0 and 1\n"}

my $reader=new GffTranscriptReader();
my $transcripts=$reader->loadGFF($filename);

open(OUT1,">$out1") || die;
open(OUT2,">$out2") || die;
my ($n1,$n2);
foreach my $transcript (@$transcripts)
  {
    my $p=rand(1);
    my $gff=$transcript->toGff();
    if($p<$percent) 
      {
	print OUT1 $gff;
	++$n1;
      }
    else
      {
	print OUT2 $gff;
	++$n2;
      }
  }
close(OUT1);
close(OUT2);
my $p1=int(100*$n1/($n1+$n2)+0.5);
my $p2=int(100*$n2/($n1+$n2)+0.5);
print "split: $n1 vs. $n2 ($p1% vs. $p2%)\n";

