/****************************************************************
 EmpiricalDistribution.H

 bmajoros@tigr.org
 ****************************************************************/

#ifndef INCL_EmpiricalDistribution_H
#define INCL_EmpiricalDistribution_H

#include "tigr++/TigrString.H"
#include "tigr++/TigrVector.H"
#include "DiscreteDistribution.H"

class EmpiricalDistribution : public DiscreteDistribution
{
  typedef pair<unsigned,double> EmpiricalDistributionElement;
  TigrVector<EmpiricalDistributionElement*> v;
  double smallestElemLogP, largestElemLogP, mean;
  int binSize;

  unsigned binarySearch(unsigned elem);
  void load(const TigrString &filename);
  void normalize();
  inline double interpolate(unsigned x1,double y1,unsigned x2,double y2,
			    unsigned x);
public:
  EmpiricalDistribution(const TigrString &filename);
  virtual ~EmpiricalDistribution();
  virtual double getLogP(unsigned);
  virtual void useLogLikelihoodRatios();
};


#endif
