/****************************************************************
 GeometricDistribution.C

 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/

#include "GeometricDistribution.H"
#include <iostream>
#include <math.h>
using namespace std;

GeometricDistribution::GeometricDistribution(int meanLength)
  : usingRatios(false)
{
  double q=1.0/meanLength;
  logQ=log(q);
  logOneMinusQ=log(1-q);
  logMean=getLogP(meanLength);
}



double GeometricDistribution::getLogP(unsigned len)
{
  // log[ (1-q)^(len-1) * q ] == (len-1)*log(1-q)+log(q)

  return (len-1)*logOneMinusQ+logQ;//-(usingRatios ? logMean : 0);
}



void GeometricDistribution::useLogLikelihoodRatios()
{
  usingRatios=true;
}




