/****************************************************************
 GffPathFromParseGraph.H
 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_GffPathFromParseGraph_H
#define INCL_GffPathFromParseGraph_H

#include "tigr++/TigrVector.H"
#include "tigr++/TigrGffTranscript.H"
#include "tigr++/TigrString.H"
#include "tigr++/Sequence.H"
#include "Signal.H"
#include "tigrscan.H"
#ifdef EXPLICIT_GRAPHS

// This is required by the standards committee screwed up vector<bool>...
typedef char BOOL;

class TigrScan;
class GffPathFromParseGraph
{
  TigrScan &tigrscan;

  void exonCoordsToSigPos(ContentType,int begin,int end,int &pos1,
			  int &pos2);
  SignalPtr getSignal(SignalType signalType,int pos,Sequence &seq,
		      const TigrString &seqStr,BOOL &found);
public:
  GffPathFromParseGraph(TigrScan &);
  TigrVector<SignalPtr> *getPathFromGff(TigrVector<TigrGffTranscript*> &,
					Sequence &,const TigrString &seqStr,
					TigrVector<BOOL> &found);
  TigrVector<int> *getSignalCoordinates(TigrVector<TigrGffTranscript*> &);
};


#endif
#endif
