/**************************************************************
ModelBuilder.H
bmajoros@tigr.org

Copyright (c) 2003, The Institute for Genomic Research (TIGR),
Rockville, Maryland, U.S.A.  All rights reserved.
***************************************************************/

#ifndef INCL_ModelBuilder_H
#define INCL_ModelBuilder_H

#include "tigr++/TigrString.H"
#include "tigr++/TigrMap.H"
#include "tigr++/TigrVector.H"
#include "tigr++/Alphabet.H"
#include "tigr++/Sequence.H"
#include "SignalSensor.H"
#include "ContentSensor.H"
#include "ModelType.H"
#include "SignalType.H"
#include "TrainingSequence.H"

class ModelBuilder
{
  Alphabet &alphabet;
  int minSampleSize, order, windowSize;
  GarbageCollector &gc;
public:
  ModelBuilder(GarbageCollector &,Alphabet &,int minSampleSize=175,
	       int order=5,int windowSize=5);
  SignalSensor *buildSignalSensor(ModelType,TigrVector<TrainingSequence*> &,
				  SignalType,int consensusOffset,
				  int consensusLength);
  ContentSensor *buildContentSensor(ModelType,TigrVector<TrainingSequence*> &,
				    ContentType);
  void changeOrder(int order);
  void changeWindowSize(int windowSize);
  void changeMinSampleSize(int minSampleSize);
};


#endif

