/****************************************************************
 NoncodingQueue.H

 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/

#ifndef INCL_NoncodingQueue_H
#define INCL_NoncodingQueue_H

#include "IntronQueue.H"

/*
  This is a special type of SignalQueue in which there can be multiple
  (overlapping) signals in the holding queue, but there can be only
  one signal in the main queue.  When a signal is ready to graduate
  from the holding queue to the main queue we see if it is better than
  the one in the main queue (i.e., has a better inductive score), and 
  if so, move it there; otherwise we discard it.
 */

class NoncodingQueue : public SignalQueue
{
  class NoncodingComparator : public SinglePhaseComparator
  {
  public:
    NoncodingComparator(ContentType,DiscreteDistribution&);
    virtual void getScores(SignalPtr,SignalPtr,double &scoreA,
			   double &scoreB);
  };
  NoncodingComparator noncodingComparator;
  double logP1;
public:
  NoncodingQueue(ContentSensor &,DiscreteDistribution &,int capacity);
  virtual void updateHoldingQueue(int position);
};


#endif
