/**************************************************************
NthOrderStringIterator.C
bmajoros@tigr.org 1/1/2003

TIGR++ : C++ class template library for bioinformatics

Copyright (c) 2003, The Institute for Genomic Research (TIGR),
Rockville, Maryland, U.S.A.  All rights reserved.
***************************************************************/

// NthOrderStringIterator.C

#include "NthOrderStringIterator.H"
#include <iostream>


NthOrderStringIterator::NthOrderStringIterator(int N,Alphabet &alphabet)
  : alphabet(alphabet), N(N), alphabetSize(alphabet.getNumElements())
{
  // ctor

  reset();
}



TigrString NthOrderStringIterator::getNextString()
{
  TigrString *s=current.toString(alphabet);
  TigrString retval=*s;
  delete s;

  advance();

  return retval;
}



bool NthOrderStringIterator::done()
{
  return !hasMore;
}



void NthOrderStringIterator::reset()
{
  Symbol z=0;
  for(int i=0 ; i<N ; ++i)
    current.append(z);
  hasMore=true;
}



void NthOrderStringIterator::advance()
{
  for(int i=N-1 ; i>=0 ; --i)
    {
      Symbol &s=current[i];
      ++s;
      if(s<alphabetSize) return;
      s=0;
    }
  hasMore=false;
}


