/**************************************************************
NthOrderStringIterator.H
bmajoros@tigr.org 1/1/2003

TIGR++ : C++ class template library for bioinformatics

Copyright (c) 2003, The Institute for Genomic Research (TIGR),
Rockville, Maryland, U.S.A.  All rights reserved.
***************************************************************/

// NthOrderStringIterator.H

#ifndef INCL_NthOrderStringIterator_H
#define INCL_NthOrderStringIterator_H

#include "tigr++/Alphabet.H"
#include "tigr++/Sequence.H"
#include "tigr++/TigrString.H"

// Generates strings of length N (not N+1!)

class NthOrderStringIterator
{
  Alphabet &alphabet;
  int alphabetSize, N;
  Sequence current;
  bool hasMore;

  void reset();
  void advance();
public:
  NthOrderStringIterator(int N,Alphabet &);
  TigrString getNextString();
  bool done();
};


#endif
