/****************************************************************
 ParseGraph.H
 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_ParseGraph_H
#define INCL_ParseGraph_H
#include "tigr++/TigrStack.H"
#include "tigr++/TigrArray1D.H"
#include "Signal.H"
#include "tigrscan.H"

class TigrScan;

#ifdef EXPLICIT_GRAPHS
class ParseGraph
{
  TigrVector<SignalPtr> *vertices;
  TigrScan &tigrscan;
public:
  ParseGraph(TigrScan &);
  virtual ~ParseGraph();
  void addVertex(SignalPtr);
  int numVertices();
  SignalPtr getIthVertex(int);
  TigrStack<SignalPtr> *findOptimalPath(double &parseScore);
  void deleteVertices(TigrArray1D<bool> &deleteIfTrue);
  void setVertexIndices();
  int findSignal(SignalType,int consensusPos); // -1 if not found
  int findFirstSignalAfter(int pos); // -1 if no signals follow pos
  int countLeftTermini();
  int countRightTermini();
};
#endif

#endif
