/**************************************************************
Partition.H
bmajoros@tigr.org

Copyright (c) 2003, The Institute for Genomic Research (TIGR),
Rockville, Maryland, U.S.A.  All rights reserved.
***************************************************************/
#ifndef INCL_Partition_H
#define INCL_Partition_H
#include <iostream>
#include "tigr++/TigrSet.H"
#include "tigr++/TigrVector.H"
#include "TrainingSequence.H"

enum Direction
  {
    DIR_LEFT,
    DIR_RIGHT
  };

class Partition
{
  int index;
  TigrSet<Symbol> leftResidues;

  void load(istream &);
public:
  Partition();
  Partition(Partition &,int index);
  Partition(istream &);
  void split(TigrVector<TrainingSequence*> &parent,
	     TigrVector<TrainingSequence*> &leftChild,
	     TigrVector<TrainingSequence*> &rightChild);
  void addSymbol(Symbol);
  void setIndex(int);
  int getIndex();
  bool isLeftSymbol(Symbol);
  void printOn(ostream &) const;
  Direction getDirection(const Sequence &,int windowBegin);
  void save(ostream &);
  Partition *reverseComplement(int sequenceLength);
  Partition *clone() const;
};

ostream &operator<<(ostream &,const Partition &);

#endif
