/****************************************************************
 ThreePeriodicMarkovChain.H

 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/

#ifndef INCL_ThreePeriodicMarkovChain_H
#define INCL_ThreePeriodicMarkovChain_H

#include "ContentSensor.H"
#include "MarkovChain.H"
class Fast3PMC;

class ThreePeriodicMarkovChain : public ContentSensor
{
  friend class Fast3PMC;
  MarkovChain *chains[3];
  
  void buildModels(TigrVector<TrainingSequence*> &,int minSampleSize,
		   int order);
  void load(istream &);
public:
  ThreePeriodicMarkovChain(const TigrString &filename);
  ThreePeriodicMarkovChain(istream &);
  ThreePeriodicMarkovChain(Strand,ContentType);
  ThreePeriodicMarkovChain(TigrVector<TrainingSequence*> &,int order,
			   int minSampleSize,ContentType);
  virtual ~ThreePeriodicMarkovChain();
  virtual double scoreSingleBase(const Sequence &,const TigrString &,int index,
				 Symbol,char);
  virtual void scoreSingleBase(const Sequence &,const TigrString &,int index,
			       Symbol,char,double &scorePhase0,
			       double &scorePhase1,
			       double &scorePhase2);
  virtual double scoreSubsequence(const Sequence &,const TigrString &,int begin,
				  int length,int seqPhase);
  virtual ContentSensor *reverseComplement();
  virtual bool save(const TigrString &filename);
  virtual void useLogOdds(ContentSensor &nullModel);
  virtual void useLogOdds_anonymous(ContentSensor &nullModel);
  virtual bool save(ostream &os);
};


#endif
