/****************************************************************
 TopologyLoader.H
 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/

#ifndef INCL_TopologyLoader_H
#define INCL_TopologyLoader_H
#include "tigr++/TigrRegex.H"
#include "SignalTypeProperties.H"

class TopologyLoader
{
  static TigrRegex transitionRegex;      // "GT -> AG : INTRON"
  static TigrRegex phaseRegex;           // "GT has phase 0"
  static TigrRegex strandRegex;          // "GT strand +"
  static TigrRegex consensusCodingRegex; // "ATG consensus coding"
  static TigrRegex commentRegex;         // "# comment"
  static TigrRegex blankLineRegex;
public:
  static SignalTypeProperties &load(const TigrString &filename);
};


#endif
