/****************************************************************
 TrainingSequence.C

 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/



#include "TrainingSequence.H"
#include <iostream>


TrainingSequence::TrainingSequence(const TigrString &seq,
				   Alphabet &alphabet)
  : boostCount(1),
    Sequence(seq,alphabet)
{
}



TrainingSequence::TrainingSequence()
  : boostCount(1)
{
}



int TrainingSequence::getBoostCount() const
{
  return boostCount;
}



void TrainingSequence::adjustBoostCount(int by)
{
  boostCount+=by;
}



Sequence *TrainingSequence::reverseComplement(Alphabet &alphabet)
{
  TrainingSequence *rc=new TrainingSequence;
  Sequence::reverseComplement(alphabet,*rc);
  rc->boostCount=boostCount;
  return rc;
}



void TrainingSequence::getSubsequence(int begin,int len,Sequence &seq) const
{
  Sequence::getSubsequence(begin,len,seq);
  TrainingSequence *ts=dynamic_cast<TrainingSequence*>(&seq);
  if(ts) ts->boostCount=boostCount;
}
