/****************************************************************
 TrainingSequence.H

 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/

#ifndef INCL_TrainingSequence_H
#define INCL_TrainingSequence_H

#include "tigr++/Sequence.H"

class TrainingSequence : public Sequence
{
public:
  TrainingSequence();
  TrainingSequence(const TigrString &seq,Alphabet &);
  int getBoostCount() const;
  void adjustBoostCount(int by);
  virtual Sequence *reverseComplement(Alphabet &);
  virtual void getSubsequence(int begin,int len,Sequence &seq) const;
private:
  int boostCount;
};


#endif
