/****************************************************************
 Transitions.H

 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/

#ifndef INCL_Transitions_H
#define INCL_Transitions_H

#include <iostream>
#include "tigr++/TigrString.H"
#include "tigr++/TigrArray2D.H"
#include "SignalType.H"

class Transitions
{
  TigrArray2D<double> matrix;
  void load(istream &);
  float optimism, intronOptimism;
public:
  Transitions(int numSignalTypes,const TigrString &filename,float optimism,
	      float intronOptimism);
  Transitions(int numSignalTypes,istream &,float optimism,float intronOptimism);
  double getLogP(SignalType from,SignalType to);
};


#endif
