/*******************************************************************
 WAM.H : Weight Array Matrix

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ******************************************************************/
#ifndef INCL_WAM_H
#define INCL_WAM_H
#include "tigr++/TigrString.H"
#include "tigr++/TigrVector.H"
#include "MarkovChain.H"
#include "SignalSensor.H"
#include "TrainingSequence.H"
#include "GarbageCollector.H"

class WAM : public SignalSensor
{
  TigrVector<MarkovChain *> matrix;

  void load(istream &);
public:
  WAM(GarbageCollector &,const WAM &, bool reverseComplement=false);
  WAM(GarbageCollector &,TigrString &filename);
  WAM(GarbageCollector &,istream &);
  WAM(GarbageCollector &,TigrVector<TrainingSequence*> &, int order, 
      int minSampleSize,SignalType,int consensusOffset,int consensusLength); 
  virtual ~WAM();
  
  virtual bool save(const TigrString &filename);
  virtual bool save(ostream &os);
  double getLogP(const Sequence &,const TigrString &,int begin);
  virtual void useLogOdds(SignalSensor &nullModel);
  virtual void useLogOdds_anonymous(ContentSensor &nullModel);
  virtual SignalSensor *reverseComplement();
};

#endif
