/****************************************************************
 WMM.H
 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_WMM_H
#define INCL_WMM_H
#include "tigr++/TigrString.H"
#include "tigr++/TigrArray2D.H"
#include "SignalSensor.H"
#include "TrainingSequence.H"
#include "GarbageCollector.H"

class WMM : public SignalSensor
{
  TigrArray2D<float> matrix;

  void load(istream &);
  void revComplementSelf();
  void swap(char,char);
  void convertToLogs();  
public:
  WMM(GarbageCollector &,const WMM &other,bool reverseComplement=false);
  WMM(GarbageCollector &,TigrString &filename);
  WMM(GarbageCollector&,istream &);
  
  // This constructor is for training:
  WMM(GarbageCollector &,TigrVector<TrainingSequence*> &,SignalType,
      int consensusOffset,int consensusLength);

  virtual SignalSensor *reverseComplement();
  virtual bool save(const TigrString &filename);
  virtual bool save(ostream &os);
  virtual void useLogOdds(SignalSensor &nullModel);
  virtual void useLogOdds_anonymous(ContentSensor &nullModel);
  double getLogP(const Sequence &,const TigrString &,int begin);
  float divergence(WMM &);
  TigrArray2D<float> &getMatrix() {return matrix;}
};


#endif
