
#######################################################################
# THIS IS A SAMPLE TRAINING SHELL SCRIPT.  THESE PARAMETERIZATIONS
# WERE USED TO TRAIN TIGRSCAN ON TOXOPLASMA GONDII, WITH REASONABLY
# SATISFYING RESULTS.  YOU MIGHT TRY THESE AS DEFAULT PARAMETERIZATIONS
# TO BEGIN WITH.  SEE THE TRAINING MANUAL FOR STEPS THAT MUST BE
# PERFORMED BEFORE RUNNING THESE COMMANDS.
#######################################################################

#======================================================================
#                       TRAIN SIGNAL SENSORS
#======================================================================

tigrscan/train-signal.pl WAM start-codons0-100.fasta non-start-codons0-100.fasta start-codons0-100 1 ATG 15 3 33 0.98 1 80 0

tigrscan/train-signal.pl WAM stop-codons0-100.fasta non-stop-codons0-100.fasta stop-codons0-100 1 TAG 0 3 53 0.98 1 80 0

tigrscan/train-signal.pl WAM donors0-100.fasta non-donors0-100.fasta donors0-100 1 GT 20 2 63 0.98 0 400 0

tigrscan/train-signal.pl WAM acceptors0-100.fasta non-acceptors0-100.fasta acceptors0-100 1 AG 25 2 43 0.98 0 80 0


#======================================================================
#                      TRAIN CONTENT SENSORS
#======================================================================

tigrscan/train-content-sensor -o 5 -s 80 3P initial-exons0-100.fasta non-initial-exons0-100.fasta initial-exons0-100 1.0 INITIAL-EXON -g

tigrscan/train-content-sensor -o 5 -s 80 3P final-exons0-100.fasta non-final-exons0-100.fasta final-exons0-100 1.0 FINAL-EXON -g

tigrscan/train-content-sensor -o 5 -s 80 3P internal-exons0-100.fasta non-internal-exons0-100.fasta internal-exons0-100 1.0 INTERNAL-EXON -g

tigrscan/train-content-sensor -o 5 -s 80 3P single-exons0-100.fasta non-single-exons0-100.fasta single-exons0-100 1.0 SINGLE-EXON -g

tigrscan/train-content-sensor -o 5 -s 80 MC introns0-100.fasta non-introns0-100.fasta introns0-100 1.0 INTRON -g

tigrscan/train-content-sensor -o 0 -s 80 MC intergenic0-100.fasta non-intergenic0-100.fasta intergenic0-100 1.0 INTERGENIC -g

tigrscan/train-content-sensor -o 1 -s 80 MC five-prime-UTR0-100.fasta three-prime-UTR0-100.fasta five-prime-UTR0-100 1.0 FIVE-PRIME-UTR -g

tigrscan/train-content-sensor -o 1 -s 80 MC three-prime-UTR0-100.fasta five-prime-UTR0-100.fasta three-prime-UTR0-100 1.0 THREE-PRIME-UTR -g


#======================================================================
#                        GET DISTRIBUTIONS
#======================================================================

tigrscan/get-distributions.pl . 5 20

tigrscan/get-trans-distr.pl iso0-100.gff > tigrscan.trans



